diff -r 091f89c47ad9 trytond/modules/stock/shipment.py
--- a/trytond/modules/stock/shipment.py	Mon Sep 10 15:28:38 2012 +0200
+++ b/trytond/modules/stock/shipment.py	Mon Sep 24 20:36:42 2012 +0200
@@ -1447,253 +1402,223 @@
         # Migration from 2.0:
         created_company = table.column_exist('company')
 
-        super(ShipmentOutReturn, self).init(module_name)
+        super(ShipmentOutReturn, cls).__register__(module_name)
 
         # Migration from 2.0:
-        move_obj = Pool().get('stock.move')
+        Move = Pool().get('stock.move')
         if (not created_company
-                and TableHandler.table_exist(cursor, move_obj._table)):
+                and TableHandler.table_exist(cursor, Move._table)):
             cursor.execute('SELECT shipment.id, MAX(move.company) '
                 'FROM "%s" AS shipment '
                 'INNER JOIN "%s" AS move '
                 'ON shipment.id = move.shipment_out_return '
                 'GROUP BY shipment.id '
                 'ORDER BY MAX(move.company)'
-                % (self._table, move_obj._table))
+                % (cls._table, Move._table))
             for company_id, values in itertools.groupby(cursor.fetchall(),
                     operator.itemgetter(1)):
                 shipment_ids = [x[0] for x in values]
                 for i in range(0, len(shipment_ids), cursor.IN_MAX):
                     sub_ids = shipment_ids[i:i + cursor.IN_MAX]
                     red_sql, red_ids = reduce_ids('id', sub_ids)
-                    cursor.execute('UPDATE "' + self._table + '" '
+                    cursor.execute('UPDATE "' + cls._table + '" '
                         'SET company = %s WHERE ' + red_sql,
                         [company_id] + red_ids)
             table.not_null_action('company', action='add')
 
         # Add index on create_date
-        table = TableHandler(cursor, self, module_name)
+        table = TableHandler(cursor, cls, module_name)
         table.index_action('create_date', action='add')
 
-    def default_state(self):
+    @staticmethod
+    def default_state():
         return 'draft'
 
-    def default_warehouse(self):
-        location_obj = Pool().get('stock.location')
-        location_ids = location_obj.search(self.warehouse.domain)
-        if len(location_ids) == 1:
-            return location_ids[0]
+    @classmethod
+    def default_warehouse(cls):
+        Location = Pool().get('stock.location')
+        locations = Location.search(cls.warehouse.domain)
+        if len(locations) == 1:
+            return locations[0].id
 
-    def default_company(self):
+    @staticmethod
+    def default_company():
         return Transaction().context.get('company')
 
-    def on_change_customer(self, values):
-        if not values.get('customer'):
+    def on_change_customer(self):
+        if not self.customer:
             return {'delivery_address': None}
-        party_obj = Pool().get("party.party")
-        address_id = party_obj.address_get(values['customer'], type='delivery')
+        address = self.customer.address_get(type='delivery')
         return {
-                'delivery_address': address_id,
+            'delivery_address': address.id,
             }
 
-    def on_change_with_customer_location(self, values):
-        pool = Pool()
-        party_obj = pool.get('party.party')
-        if values.get('customer'):
-            customer = party_obj.browse(values['customer'])
-            return customer.customer_location.id
+    def on_change_with_customer_location(self, name=None):
+        if self.customer:
+            return self.customer.customer_location.id
 
-    def get_customer_location(self, ids, name):
-        locations = {}
-        for shipment in self.browse(ids):
-            locations[shipment.id] = shipment.customer.customer_location.id
-        return locations
+    @classmethod
+    def default_warehouse_storage(cls):
+        warehouse = cls.default_warehouse()
+        if warehouse:
+            return cls(warehouse=warehouse).on_change_with_warehouse_storage()
 
-    def default_warehouse_storage(self):
-        warehouse = self.default_warehouse()
+    def on_change_with_warehouse_storage(self, name=None):
+        if self.warehouse:
+            return self.warehouse.storage_location.id
+
+    @classmethod
+    def default_warehouse_input(cls):
+        warehouse = cls.default_warehouse()
         if warehouse:
-            value = self.on_change_with_warehouse_storage({
-                    'warehouse': warehouse,
-                    })
-            return value
+            return cls(warehouse=warehouse).on_change_with_warehouse_input()
 
-    def on_change_with_warehouse_storage(self, values):
-        pool = Pool()
-        location_obj = pool.get('stock.location')
-        if values.get('warehouse'):
-            warehouse = location_obj.browse(values['warehouse'])
-            return warehouse.storage_location.id
+    def on_change_with_warehouse_input(self, name=None):
+        if self.warehouse:
+            return self.warehouse.input_location.id
 
-    def get_warehouse_storage(self, ids, name):
-        storages = {}
-        for shipment in self.browse(ids):
-            storages[shipment.id] = shipment.warehouse.storage_location.id
-        return storages
+    def get_incoming_moves(self, name):
+        moves = []
+        for move in self.moves:
+            if move.to_location.id == self.warehouse.input_location.id:
+                moves.append(move.id)
+        return moves
 
-    def default_warehouse_input(self):
-        warehouse = self.default_warehouse()
-        if warehouse:
-            value = self.on_change_with_warehouse_input({
-                    'warehouse': warehouse,
-                    })
-            return value
-
-    def on_change_with_warehouse_input(self, values):
-        pool = Pool()
-        location_obj = pool.get('stock.location')
-        if values.get('warehouse'):
-            warehouse = location_obj.browse(values['warehouse'])
-            return warehouse.input_location.id
-
-    def get_warehouse_input(self, ids, name):
-        inputs = {}
-        for shipment in self.browse(ids):
-            inputs[shipment.id] = shipment.warehouse.input_location.id
-        return inputs
-
-    def get_incoming_moves(self, ids, name):
-        res = {}
-        for shipment in self.browse(ids):
-            res[shipment.id] = []
-            for move in shipment.moves:
-                if move.to_location.id == \
-                        shipment.warehouse.input_location.id:
-                    res[shipment.id].append(move.id)
-        return res
-
-    def set_incoming_moves(self, ids, name, value):
+    @classmethod
+    def set_incoming_moves(cls, shipments, name, value):
         if not value:
             return
-        self.write(ids, {
-            'moves': value,
-            })
+        cls.write(shipments, {
+                'moves': value,
+                })
 
-    def get_inventory_moves(self, ids, name):
-        res = {}
-        for shipment in self.browse(ids):
-            res[shipment.id] = []
-            for move in shipment.moves:
-                if move.from_location.id == \
-                        shipment.warehouse.input_location.id:
-                    res[shipment.id].append(move.id)
-        return res
+    def get_inventory_moves(self, name):
+        moves = []
+        for move in self.moves:
+            if move.from_location.id == self.warehouse.input_location.id:
+                moves.append(move.id)
+        return moves
 
-    def set_inventory_moves(self, ids, name, value):
+    @classmethod
+    def set_inventory_moves(cls, shipments, name, value):
         if not value:
             return
-        self.write(ids, {
-            'moves': value,
-            })
+        cls.write(shipments, {
+                'moves': value,
+                })
 
-    def _get_move_planned_date(self, shipment):
+    def _get_move_planned_date(self):
         '''
         Return the planned date for incoming moves and inventory moves
         '''
-        return shipment.planned_date, shipment.planned_date
+        return self.planned_date, self.planned_date
 
-    def _set_move_planned_date(self, shipment_ids):
+    @classmethod
+    def _set_move_planned_date(cls, shipments):
         '''
         Set planned date of moves for the shipments
         '''
-        move_obj = Pool().get('stock.move')
-        if isinstance(shipment_ids, (int, long)):
-            shipment_ids = [shipment_ids]
-        for shipment in self.browse(shipment_ids):
-            dates = self._get_move_planned_date(shipment)
+        Move = Pool().get('stock.move')
+        for shipment in shipments:
+            dates = shipment._get_move_planned_date()
             incoming_date, inventory_date = dates
-            move_obj.write([x.id for x in shipment.incoming_moves
+            Move.write([x for x in shipment.incoming_moves
                     if x.state not in ('assigned', 'done', 'cancel')], {
                     'planned_date': incoming_date,
                     })
-            move_obj.write([x.id for x in shipment.inventory_moves
+            Move.write([x for x in shipment.inventory_moves
                     if x.state not in ('assigned', 'done', 'cancel')], {
                     'planned_date': inventory_date,
                     })
 
-    def create(self, values):
-        sequence_obj = Pool().get('ir.sequence')
-        config_obj = Pool().get('stock.configuration')
+    @classmethod
+    def create(cls, values):
+        pool = Pool()
+        Sequence = pool.get('ir.sequence')
+        Config = pool.get('stock.configuration')
 
         values = values.copy()
-        config = config_obj.browse(1)
-        values['code'] = sequence_obj.get_id(
+        config = Config(1)
+        values['code'] = Sequence.get_id(
                 config.shipment_out_return_sequence.id)
-        shipment_id = super(ShipmentOutReturn, self).create(values)
-        self._set_move_planned_date(shipment_id)
-        return shipment_id
+        shipment = super(ShipmentOutReturn, cls).create(values)
+        cls._set_move_planned_date([shipment])
+        return shipment
 
-    def write(self, ids, values):
-        result = super(ShipmentOutReturn, self).write(ids, values)
-        self._set_move_planned_date(ids)
-        return result
+    @classmethod
+    def write(cls, shipments, values):
+        super(ShipmentOutReturn, cls).write(shipments, values)
+        cls._set_move_planned_date(shipments)
 
-    def copy(self, ids, default=None):
+    @classmethod
+    def copy(cls, shipments, default=None):
         if default is None:
             default = {}
         default = default.copy()
         default['inventory_moves'] = None
         default['incoming_moves'] = None
-        return super(ShipmentOutReturn, self).copy(ids, default=default)
+        return super(ShipmentOutReturn, cls).copy(shipments, default=default)
 
-    def delete(self, ids):
-        if isinstance(ids, (int, long)):
-            ids = [ids]
+    @classmethod
+    def delete(cls, shipments):
         # Cance before delete
-        self.cancel(ids)
-        for shipment in self.browse(ids):
+        cls.cancel(shipments)
+        for shipment in shipments:
             if shipment.state != 'cancel':
-                self.raise_user_error('delete_cancel', shipment.rec_name)
-        return super(ShipmentOutReturn, self).delete(ids)
+                cls.raise_user_error('delete_cancel', shipment.rec_name)
+        super(ShipmentOutReturn, cls).delete(shipments)
 
+    @classmethod
     @ModelView.button
     @Workflow.transition('draft')
-    def draft(self, ids):
-        move_obj = Pool().get('stock.move')
-        shipments = self.browse(ids)
-        move_obj.write([m.id for s in shipments for m in s.incoming_moves
+    def draft(cls, shipments):
+        Move = Pool().get('stock.move')
+        Move.write([m for s in shipments for m in s.incoming_moves
                 if m.state not in ('draft', 'done')], {
                 'state': 'draft',
                 })
-        move_obj.delete([m.id for s in shipments for m in s.inventory_moves
+        Move.delete([m for s in shipments for m in s.inventory_moves
                 if m.state in ('draft', 'cancel')])
 
+    @classmethod
     @ModelView.button
     @Workflow.transition('received')
-    def receive(self, ids):
-        move_obj = Pool().get('stock.move')
-        shipments = self.browse(ids)
-        move_obj.write([m.id for s in shipments for m in s.incoming_moves
+    def receive(cls, shipments):
+        Move = Pool().get('stock.move')
+        Move.write([m for s in shipments for m in s.incoming_moves
                 if m.state not in ('done', 'cancel')], {
                 'state': 'done',
                 })
-        self.create_inventory_moves(shipments)
+        cls.create_inventory_moves(shipments)
 
+    @classmethod
     @ModelView.button
     @Workflow.transition('done')
-    def done(self, ids):
-        move_obj = Pool().get('stock.move')
-        date_obj = Pool().get('ir.date')
-        shipments = self.browse(ids)
-        move_obj.write([m.id for s in shipments for m in s.inventory_moves
+    def done(cls, shipments):
+        pool = Pool()
+        Move = pool.get('stock.move')
+        Date = pool.get('ir.date')
+        Move.write([m for s in shipments for m in s.inventory_moves
                 if m.state not in ('done', 'cancel')], {
                 'state': 'done',
                 })
-        self.write(ids, {
-                'effective_date': date_obj.today(),
+        cls.write(shipments, {
+                'effective_date': Date.today(),
                 })
 
+    @classmethod
     @ModelView.button
     @Workflow.transition('cancel')
-    def cancel(self, ids):
-        move_obj = Pool().get('stock.move')
-        shipments = self.browse(ids)
-        move_obj.write([m.id for s in shipments
+    def cancel(cls, shipments):
+        Move = Pool().get('stock.move')
+        Move.write([m for s in shipments
                 for m in s.incoming_moves + s.inventory_moves
                 if m.state not in ('cancel', 'done')], {
                 'state': 'cancel',
                 })
 
-    def _get_inventory_moves(self, incoming_move):
+    @staticmethod
+    def _get_inventory_moves(incoming_move):
         res = {}
         if incoming_move.quantity <= 0.0:
             return None
@@ -1710,41 +1635,36 @@
         res['company'] = incoming_move.company.id
         return res
 
-    def create_inventory_moves(self, shipments):
+    @classmethod
+    def create_inventory_moves(cls, shipments):
         for shipment in shipments:
             for incoming_move in shipment.incoming_moves:
-                vals = self._get_inventory_moves(incoming_move)
+                vals = cls._get_inventory_moves(incoming_move)
                 if vals:
-                    self.write(shipment.id, {
+                    cls.write([shipment], {
                         'inventory_moves': [('create', vals)],
                         })
 
-ShipmentOutReturn()
-
 
 class AssignShipmentOutAssignFailed(ModelView):
     'Assign Shipment Out'
-    _name = 'stock.shipment.out.assign.failed'
-    _description = __doc__
+    __name__ = 'stock.shipment.out.assign.failed'
+    inventory_moves = fields.Many2Many('stock.move', None, None,
+        'Inventory Moves', readonly=True)
 
-    inventory_moves = fields.Many2Many('stock.move', None, None,
-            'Inventory Moves', readonly=True)
-
-    def default_inventory_moves(self):
-        shipment_out_obj = Pool().get('stock.shipment.out')
+    @staticmethod
+    def default_inventory_moves():
+        ShipmentOut = Pool().get('stock.shipment.out')
         shipment_id = Transaction().context.get('active_id')
         if not shipment_id:
             return []
-        shipment = shipment_out_obj.browse(shipment_id)
+        shipment = ShipmentOut(shipment_id)
         return [x.id for x in shipment.inventory_moves if x.state == 'draft']
 
-AssignShipmentOutAssignFailed()
-
 
 class AssignShipmentOut(Wizard):
     'Assign Shipment Out'
-    _name = 'stock.shipment.out.assign'
-
+    __name__ = 'stock.shipment.out.assign'
     start = StateTransition()
     failed = StateView('stock.shipment.out.assign.failed',
         'stock.shipment_out_assign_failed_view_form', [
@@ -1758,30 +1678,26 @@
             ])
     force = StateTransition()
 
-    def transition_start(self, session):
+    def transition_start(self):
         pool = Pool()
-        shipment_obj = pool.get('stock.shipment.out')
+        Shipment = pool.get('stock.shipment.out')
 
-        if shipment_obj.assign_try([Transaction().context['active_id']]):
+        if Shipment.assign_try([Shipment(Transaction().context['active_id'])]):
             return 'end'
         else:
             return 'failed'
 
-    def transition_force(self, session):
-        shipment_obj = Pool().get('stock.shipment.out')
+    def transition_force(self):
+        Shipment = Pool().get('stock.shipment.out')
 
-        shipment_obj.assign_force([Transaction().context['active_id']])
+        Shipment.assign_force([Shipment(Transaction().context['active_id'])])
         return 'end'
 
-AssignShipmentOut()
-
 
 class ShipmentInternal(Workflow, ModelSQL, ModelView):
     "Internal Shipment"
-    _name = 'stock.shipment.internal'
-    _description = __doc__
+    __name__ = 'stock.shipment.internal'
     _rec_name = 'code'
-
     effective_date = fields.Date('Effective Date', readonly=True)
     planned_date = fields.Date('Planned Date',
         states={
@@ -1838,14 +1754,15 @@
         ('done', 'Done'),
         ], 'State', readonly=True)
 
-    def __init__(self):
-        super(ShipmentInternal, self).__init__()
-        self._order[0] = ('id', 'DESC')
-        self._error_messages.update({
+    @classmethod
+    def __setup__(cls):
+        super(ShipmentInternal, cls).__setup__()
+        cls._order[0] = ('id', 'DESC')
+        cls._error_messages.update({
                 'delete_cancel': 'Internal Shipment "%s" must be cancelled '\
                     'before deletion!',
                 })
-        self._transitions |= set((
+        cls._transitions |= set((
                 ('draft', 'waiting'),
                 ('waiting', 'waiting'),
                 ('waiting', 'assigned'),
@@ -1857,7 +1774,7 @@
                 ('assigned', 'cancel'),
                 ('cancel', 'draft'),
                 ))
-        self._buttons.update({
+        cls._buttons.update({
                 'cancel': {
                     'invisible': Eval('state').in_(['cancel', 'done']),
                     },
@@ -1888,13 +1805,14 @@
                 'assign_force': {},
                 })
 
-    def init(self, module_name):
+    @classmethod
+    def __register__(cls, module_name):
         cursor = Transaction().cursor
         # Migration from 1.2: packing renamed into shipment
         old_table = 'stock_packing_internal'
         if TableHandler.table_exist(cursor, old_table):
-            TableHandler.table_rename(cursor, old_table, self._table)
-        table = TableHandler(cursor, self, module_name)
+            TableHandler.table_rename(cursor, old_table, cls._table)
+        table = TableHandler(cursor, cls, module_name)
         for field in ('create_uid', 'write_uid', 'from_location',
                 'to_location'):
             table.drop_fk(field, table=old_table)
@@ -1904,174 +1822,172 @@
         # Migration from 2.0:
         created_company = table.column_exist('company')
 
-        super(ShipmentInternal, self).init(module_name)
+        super(ShipmentInternal, cls).__register__(module_name)
 
         # Migration from 2.0:
-        move_obj = Pool().get('stock.move')
+        Move = Pool().get('stock.move')
         if (not created_company
-                and TableHandler.table_exist(cursor, move_obj._table)):
+                and TableHandler.table_exist(cursor, Move._table)):
             cursor.execute('SELECT shipment.id, MAX(move.company) '
                 'FROM "%s" AS shipment '
                 'INNER JOIN "%s" AS move '
                 'ON shipment.id = move.shipment_internal '
                 'GROUP BY shipment.id '
                 'ORDER BY MAX(move.company)'
-                % (self._table, move_obj._table))
+                % (cls._table, Move._table))
             for company_id, values in itertools.groupby(cursor.fetchall(),
                     operator.itemgetter(1)):
                 shipment_ids = [x[0] for x in values]
                 for i in range(0, len(shipment_ids), cursor.IN_MAX):
                     sub_ids = shipment_ids[i:i + cursor.IN_MAX]
                     red_sql, red_ids = reduce_ids('id', sub_ids)
-                    cursor.execute('UPDATE "' + self._table + '" '
+                    cursor.execute('UPDATE "' + cls._table + '" '
                         'SET company = %s WHERE ' + red_sql,
                         [company_id] + red_ids)
             table.not_null_action('company', action='add')
 
         # Add index on create_date
-        table = TableHandler(cursor, self, module_name)
+        table = TableHandler(cursor, cls, module_name)
         table.index_action('create_date', action='add')
 
-    def default_state(self):
+    @staticmethod
+    def default_state():
         return 'draft'
 
-    def default_company(self):
+    @staticmethod
+    def default_company():
         return Transaction().context.get('company')
 
-    def create(self, values):
-        sequence_obj = Pool().get('ir.sequence')
-        config_obj = Pool().get('stock.configuration')
+    @classmethod
+    def create(cls, values):
+        pool = Pool()
+        Sequence = pool.get('ir.sequence')
+        Config = pool.get('stock.configuration')
 
         values = values.copy()
-        config = config_obj.browse(1)
-        values['code'] = sequence_obj.get_id(
+        config = Config(1)
+        values['code'] = Sequence.get_id(
                 config.shipment_internal_sequence.id)
-        return super(ShipmentInternal, self).create(values)
+        return super(ShipmentInternal, cls).create(values)
 
-    def delete(self, ids):
-        if isinstance(ids, (int, long)):
-            ids = [ids]
+    @classmethod
+    def delete(cls, shipments):
         # Cancel before delete
-        self.cancel(ids)
-        for shipment in self.browse(ids):
+        cls.cancel(shipments)
+        for shipment in shipments:
             if shipment.state != 'cancel':
-                self.raise_user_error('delete_cancel', shipment.rec_name)
-        return super(ShipmentInternal, self).delete(ids)
+                cls.raise_user_error('delete_cancel', shipment.rec_name)
+        super(ShipmentInternal, cls).delete(shipments)
 
+    @classmethod
     @ModelView.button
     @Workflow.transition('draft')
-    def draft(self, ids):
-        move_obj = Pool().get('stock.move')
-        shipments = self.browse(ids)
-        move_obj.write([m.id for s in shipments for m in s.moves
+    def draft(cls, shipments):
+        Move = Pool().get('stock.move')
+        Move.write([m for s in shipments for m in s.moves
                 if m.state not in ('draft', 'done')], {
                 'state': 'draft',
                 })
 
+    @classmethod
     @ModelView.button
     @Workflow.transition('waiting')
-    def wait(self, ids):
-        move_obj = Pool().get('stock.move')
-        shipments = self.browse(ids)
+    def wait(cls, shipments):
+        Move = Pool().get('stock.move')
         # First reset state to draft to allow update from and to location
-        move_obj.write([m.id for s in shipments for m in s.moves
+        Move.write([m for s in shipments for m in s.moves
                 if m.state not in ('draft', 'done')], {
                 'state': 'draft',
                 })
         for shipment in shipments:
-            move_obj.write([m.id for m in shipment.moves
+            Move.write([m for m in shipment.moves
                     if m.state != 'done'], {
                 'from_location': shipment.from_location.id,
                 'to_location': shipment.to_location.id,
                 'planned_date': shipment.planned_date,
                 })
 
+    @classmethod
     @Workflow.transition('assigned')
-    def assign(self, ids):
+    def assign(cls, shipments):
         pass
 
+    @classmethod
     @ModelView.button
     @Workflow.transition('done')
-    def done(self, ids):
-        move_obj = Pool().get('stock.move')
-        date_obj = Pool().get('ir.date')
-        shipments = self.browse(ids)
-        move_obj.write([m.id for s in shipments for m in s.moves
+    def done(cls, shipments):
+        pool = Pool()
+        Move = pool.get('stock.move')
+        Date = pool.get('ir.date')
+        Move.write([m for s in shipments for m in s.moves
                 if m.state not in ('done', 'cancel')], {
                 'state': 'done',
                 })
-        self.write(ids, {
-                'effective_date': date_obj.today(),
+        cls.write(shipments, {
+                'effective_date': Date.today(),
                 })
 
+    @classmethod
     @ModelView.button
     @Workflow.transition('cancel')
-    def cancel(self, ids):
-        move_obj = Pool().get('stock.move')
-        shipments = self.browse(ids)
-        move_obj.write([m.id for s in shipments for m in s.moves
+    def cancel(cls, shipments):
+        Move = Pool().get('stock.move')
+        Move.write([m for s in shipments for m in s.moves
                 if m.state not in ('cancel', 'done')], {
                 'state': 'cancel',
                 })
 
+    @classmethod
     @ModelView.button_action('stock.wizard_shipment_internal_assign')
-    def assign_wizard(self, ids):
+    def assign_wizard(cls, shipments):
         pass
 
+    @classmethod
     @ModelView.button
-    def assign_try(self, ids):
-        move_obj = Pool().get('stock.move')
-        shipments = self.browse(ids)
-        if move_obj.assign_try([m for s in shipments
+    def assign_try(cls, shipments):
+        Move = Pool().get('stock.move')
+        if Move.assign_try([m for s in shipments
                     for m in s.moves]):
-            self.assign(ids)
+            cls.assign(shipments)
             return True
         else:
             return False
 
+    @classmethod
     @ModelView.button
-    def assign_force(self, ids):
-        move_obj = Pool().get('stock.move')
-        shipments = self.browse(ids)
-        move_obj.write([m.id for s in shipments for m in s.moves
+    def assign_force(cls, shipments):
+        Move = Pool().get('stock.move')
+        Move.write([m for s in shipments for m in s.moves
                 if m.state not in ('assigned', 'done')], {
                 'state': 'assigned',
                 })
-        self.assign(ids)
+        cls.assign(shipments)
 
-ShipmentInternal()
 
-
-class Address(ModelSQL, ModelView):
-    _name = 'party.address'
+class Address:
+    __name__ = 'party.address'
     delivery = fields.Boolean('Delivery')
 
-Address()
-
 
 class AssignShipmentInternalAssignFailed(ModelView):
     'Assign Shipment Internal'
-    _name = 'stock.shipment.internal.assign.failed'
-    _description = __doc__
+    __name__ = 'stock.shipment.internal.assign.failed'
+    moves = fields.Many2Many('stock.move', None, None, 'Moves',
+        readonly=True)
 
-    moves = fields.Many2Many('stock.move', None, None, 'Moves',
-            readonly=True)
-
-    def default_moves(self):
-        shipment_internal_obj = Pool().get('stock.shipment.internal')
+    @staticmethod
+    def default_moves():
+        ShipmentInternal = Pool().get('stock.shipment.internal')
         shipment_id = Transaction().context.get('active_id')
         if not shipment_id:
             return []
-        shipment = shipment_internal_obj.browse(shipment_id)
+        shipment = ShipmentInternal(shipment_id)
         return [x.id for x in shipment.moves if x.state == 'draft']
 
-AssignShipmentInternalAssignFailed()
-
 
 class AssignShipmentInternal(Wizard):
     'Assign Shipment Internal'
-    _name = 'stock.shipment.internal.assign'
-
+    __name__ = 'stock.shipment.internal.assign'
     start = StateTransition()
     failed = StateView('stock.shipment.internal.assign.failed',
         'stock.shipment_internal_assign_failed_view_form', [
@@ -2085,47 +2001,41 @@
             ])
     force = StateTransition()
 
-    def transition_start(self, session):
+    def transition_start(self):
         pool = Pool()
-        shipment_obj = pool.get('stock.shipment.internal')
+        Shipment = pool.get('stock.shipment.internal')
 
-        if shipment_obj.assign_try([Transaction().context['active_id']]):
+        if Shipment.assign_try([Shipment(Transaction().context['active_id'])]):
             return 'end'
         else:
             return 'failed'
 
-    def transition_force(self, session):
-        shipment_obj = Pool().get('stock.shipment.internal')
+    def transition_force(self):
+        Shipment = Pool().get('stock.shipment.internal')
 
-        shipment_obj.assign_force([Transaction().context['active_id']])
+        Shipment.assign_force([Shipment(Transaction().context['active_id'])])
         return 'end'
 
-AssignShipmentInternal()
-
 
 class AssignShipmentInReturnAssignFailed(ModelView):
     'Assign Supplier Return Shipment'
-    _name = 'stock.shipment.in.return.assign.failed'
-    _description = __doc__
-
+    __name__ = 'stock.shipment.in.return.assign.failed'
     moves = fields.Many2Many('stock.move', None, None, 'Moves',
             readonly=True)
 
-    def default_moves(self):
-        shipment_internal_obj = Pool().get('stock.shipment.in.return')
+    @staticmethod
+    def default_moves():
+        ShipmentInternal = Pool().get('stock.shipment.in.return')
         shipment_id = Transaction().context.get('active_id')
         if not shipment_id:
             return []
-        shipment = shipment_internal_obj.browse(shipment_id)
+        shipment = ShipmentInternal(shipment_id)
         return [x.id for x in shipment.moves if x.state == 'draft']
 
-AssignShipmentInReturnAssignFailed()
-
 
 class AssignShipmentInReturn(Wizard):
     'Assign Supplier Return Shipment'
-    _name = 'stock.shipment.in.return.assign'
-
+    __name__ = 'stock.shipment.in.return.assign'
     start = StateTransition()
     failed = StateView('stock.shipment.in.return.assign.failed',
         'stock.shipment_in_return_assign_failed_view_form', [
